package com.shanghaichengdi.ghjgitem.controller;

import com.alibaba.fastjson.JSONObject;
import com.shanghaichengdi.ghjgitem.constant.HttpStatus;
import com.shanghaichengdi.ghjgitem.service.HyDangerPreDeclareNhService;
import com.shanghaichengdi.ghjgitem.util.CommonTools;
import com.shanghaichengdi.ghjgitem.vo.HyDangerPreDeclareNhVo;
import com.shanghaichengdi.ghjgitem.vo.ObjectBodyVo;
import com.shanghaichengdi.ghjgitem.vo.request.DangerDeclareGoodsReq;
import com.shanghaichengdi.ghjgitem.vo.response.ResultRes;
import com.shanghaichengdi.ghjgitem.vo.response.ReturnMsg;
import java.util.List;
import javax.annotation.Resource;
import lombok.extern.slf4j.Slf4j;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.CrossOrigin;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
@CrossOrigin
@RequestMapping("/dangerNh")
@Slf4j
public class DangerDeclareController extends CommonController {

  @Resource
  private HyDangerPreDeclareNhService dangerPreDeclareNhService;

  @PostMapping("/getDeclareGoodsListSync")
  public ReturnMsg getDeclareGoodsList(@RequestBody @Validated ObjectBodyVo vo) {
    if (!checkDbKey(vo.getKey())) {
      return ReturnMsg.error(HttpStatus.BAD_REQUEST, "key值有误,请确认您输入的key值正确!");
    }
    String paramJsonData = getParamJsonData(vo.getData());
    DangerDeclareGoodsReq req = JSONObject.parseObject(paramJsonData,
        DangerDeclareGoodsReq.class);
    List<HyDangerPreDeclareNhVo> dangerPreDeclareNhVoList = dangerPreDeclareNhService.selectDeclareGoodsList(
        req);
    ResultRes resultRes = ResultRes.encapsulationResult(req.getPageIndex(),
        req.getPageSize(),
        CommonTools.getTotal(dangerPreDeclareNhVoList), dangerPreDeclareNhVoList);
    String jsonString = JSONObject.toJSONString(resultRes);
    String encodedData = resultEncode(jsonString);
    return ReturnMsg.success("获取成功", encodedData);
  }
}
